-------------------------------------------------------------
--	Filename:  OUT_TEST.VHD
-- Author: Adam Kwiatkowski / MSS
--	Version: 1
--	Date last modified: 1/26/12
-- Inheritance: 	none
--
-- Description: test NPINS pin connectors
-- Simple modulo 2^NPINS counter, continuous.
--
-- Rev 1 1/26/12 AZ
-- Added generic for parametric number of tested input pins
---------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity OUT_TEST is 
Generic (

	NPINS: integer := 30
		-- number of pins being tested 
	);
port ( 

	--// Clock
	CLK : in std_logic;		-- Main internal processing clock

	--// User Interface
	ENABLE : in std_logic;		-- test enable

	TPS: out std_logic_vector(10 downto 1);		-- test points

	DATA_OUT: out std_logic_vector(NPINS downto 1)
--	ERROR : out std_logic;


);
end entity;

architecture behavioral of OUT_TEST is
--------------------------------------------------------
--      COMPONENTS
--------------------------------------------------------

--------------------------------------------------------
--     SIGNALS
--------------------------------------------------------
signal DATA_COUNTER: std_logic_vector(NPINS downto 1) := (others => '0');

--------------------------------------------------------
--      IMPLEMENTATION
--------------------------------------------------------

begin
MAIN_001: process(CLK)
begin
	if rising_edge(CLK) then
--		if(ENABLE = '1') then
			DATA_COUNTER  <= DATA_COUNTER + 1;
--		end if;						
	end if;						
end process;

DATA_OUT <= DATA_COUNTER when (ENABLE = '1') else (others => 'Z');

TPS(1) <= '1' when (DATA_COUNTER = 0) else '0';
--TPS(2) <= DAC_READY;

end behavioral;

